
# --- PostgreSQL -------------------------------------------------------------
sub _CreateDataSource
# ----------------------------------------------------------------------------
{
   my $hSelfPI   = shift;

   $hSelfPI->{"DataSource"} =
       sprintf("dbi:%s:%s",
               $hSelfPI->{"DbDriver"},
               $hSelfPI->{"DbName"});

   return $hSelfPI->{"DataSource"};
}

sub DateFromDb($$)
# ----------------------------------------------------------------------------
{
   my $hSelfPI  = shift;
   my $cFieldPI = shift;

   my $cResult = timestamp_Db2Form($cFieldPI);

   return $cResult;

}


sub DateToDb($$)
# ----------------------------------------------------------------------------
{
   my $hSelfPI  = shift;
   my $cFieldPI = shift;

   my $cResult = timestamp_Form2Db($cFieldPI);

   return $cResult;

}



# ----------------------------------------------------------------------------
sub timestamp_Db2Form($)
{
   my $cFieldPI = shift;
   my $cResult = $cFieldPI;

   my @lLocaltime;

   # Format: YYYY-MM-DD hh:mm:ss
   @lLocaltime = DbSession::ParseDate("%Y-%m-%d %H:%M:%S", $cFieldPI);

   $cResult = (DbSession::PrintDate("%d.%m.%Y %H:%M:%S", @lLocaltime) ||
               $cResult);

   return $cResult;
}


# ----------------------------------------------------------------------------
sub timestamp_Form2Db($)
{
   my $cFieldPI = shift;
   my $cResult = $cFieldPI;

   # my $cResult = $cFieldPI;
   my @lLocaltime;

   # Format: YYYY-MM-DD hh:mm:ss
   @lLocaltime = DbSession::ScanDate($cFieldPI);

   $cResult = (DbSession::PrintDate("%Y-%m-%d %H:%M:%S", @lLocaltime) ||
               $cResult);

   return $cResult;
}

1;
