#!/usr/bin/perl
# -----------------------------------------------------------------------------
# TWC
# Treuwert-Computer GmbH
# Schlobergring 9
# 79098 Freiburg
#
# Author: Klaus Reger <K.Reger@twc.de>
#
# -----------------------------------------------------------------------------
# Program-Data
# -----------------------------------------------------------------------------
# Project  :
# System   :
# Program  :
# Module   : $RCSfile: mysql.pm,v $
# Version  : $Revision: 1.4 $
# Date     : $Date: 2003/04/16 11:36:40 $
# State    : $State: Exp $
#
# Description:
#   This module handles all the things of WWWdb, which have
#   to do with DbSessions
#
# Change-log (See at end of this file)
#
# --- Known Bugs -------------
# please look at the BUGS-File
# --- TODO -------------------
# please look at the TODO-File
# ----------------------------------------------------------------------------

use POSIX qw(strftime);

use strict;
use DBI;
package DbSession;

use vars qw(@lDbTimestampScanFormats @lDbTimeScanFormats);

@lDbTimestampScanFormats = ("%Y-%m-%d %H:%M:%S");
@lDbTimeScanFormats      = ("%H:%M:%S");

# --- MySql ------------------------------------------------------------------
sub _CreateDataSource
# ----------------------------------------------------------------------------
{
   my $hSelfPI   = shift;

   $hSelfPI->{"DataSource"} =
       sprintf("dbi:%s" .
               "(RaiseError=>%d, PrintError=>%d, AutoCommit=>%d)" .
               ":database=%s;%s",
               $hSelfPI->{"DbDriver"},
               $hSelfPI->{"RaiseError"},
               $hSelfPI->{"PrintError"},
               $hSelfPI->{"AutoCommit"},
               $hSelfPI->{"DbName"},
               ($hSelfPI->{"DbHost"}?
                "host=" . $hSelfPI->{"DbHost"}:
                ""));

   return $hSelfPI->{"DataSource"};
}


sub DateFromDb($$;$)
# ----------------------------------------------------------------------------
{
   my $hSelfPI   = shift;
   my $cFieldPI  = shift;
   my $cFormatPI = shift;

   my $cResult = &DbSession::PrintDate
       ($cFormatPI || $hSelfPI->getDatePrintFormat(),
        # Patch from Norbert Bierlox <Norbert.Bierlox@fun.de>
        &DbSession::ScanDate($cFieldPI, @lDbTimeScanFormats)) ||
        $cFieldPI;

    return $cResult;

}


sub DateToDb($$)
# ----------------------------------------------------------------------------
{
   my $hSelfPI  = shift;
   my $cFieldPI = shift;

   my $cResult = &DbSession::PrintDate
       ($lDbTimestampScanFormats[0],
        &DbSession::ScanDate($cFieldPI,
                             @{$hSelfPI->getDateScanFormats()})) ||
                                 $cFieldPI;

   return $cResult;

}


# --- Convert datetime-fields from form to db ---------------------------------
sub SQL_TIMESTAMP_Form2Db ($$)
{
   return &DateToDb(shift, shift);

}

# --- Convert datetime-fields from db to form ---------------------------------
sub SQL_TIMESTAMP_Db2Form ($$)
{
   return &DateFromDb(shift, shift);
}

# --- only dummy at the moment --------------------------------------
sub MapDatatype($)
{
    my $iDatatypePI = shift;

    return $iDatatypePI;
}


1;

